
/*
 * This is a little test application to test your eclipse IDE with the
 * GNUARM-Toolchain and newlib-lpc_rel_2 provided by aeolus
 */

#include <stdio.h>
#include <errno.h>

#include <lpc210x.h>
#include <dev_cntrl.h>
#include <lpc_ioctl.h>
#include <lpc_sys.h>

/*
 * device table
 * list of device drivers for newlib
 */
const struct device_table_entry *device_table[] = {
	&com1,	/* stdin  */
	&com1,	/* stdout */
	&com1,	/* stderr */
	0 };	/* end of list */


int
main(void)
{
	struct serial_param sp;
	
	/*
	 * set oscillator frequency (round it up ;)
	 * 14746kHz (14,7456MHz)
	 */
	SetNativeSpeed(_impure_ptr, 14746uL);
	
	/*
	 * desired serial line characteristics:
	 * 115200 baud, 8 data-bits, no parity and 1 stop-bit
	 */
	sp.baud		= 115200uL;
	sp.length	= UART_WORD_LEN_8;
	sp.parity	= UART_PARITY_NONE;
	sp.stop		= UART_STOP_BITS_1;
	
	/*
	 * set up memory access, CPU and bus speeds, this may be very oversized,
	 * just copied and pasted from the newlib examples...
	 */
	SetMAM(_impure_ptr, 3u, MAM_full_enable);
	VPBControl(_impure_ptr, VPB_DIV1);
	SetDesiredSpeed(_impure_ptr, 60000uL);

	/*
	 * set up serial port to desired parameters
	 */
	ioctl(fileno(stdout), UART_SETUP, &sp);

	/*
	 * here we go...
	 */
	puts("Hello, World!\r\n\r\n______________________________________________________________________________");
	puts("http://wiki.mikrocontroller.net | http://www.mikrocontroller.net\r\n");
	
	/*
	 * echo anything read on the line...
	 */
	while(1)
	{
		fputc(getchar(), stdout);
    }

	/* NEVEREACHED */
	return(0);
}
